package turtle;

/** A widget for entering ints.
 * <p>Title: Turtle-talk</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Mmorial University</p>
 * @author Theodore Norvell
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.* ;
import javax.swing.*;
import javax.swing.event.*;

class Counter extends JPanel implements ChangeListener {
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JTextField numberField = new JTextField();
  JButton increButton = new JButton();
  JButton decrButton = new JButton();
  BoundedRangeModel brm ;

  public Counter( ) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setLayout(gridBagLayout1);
    increButton.setFont(new java.awt.Font("Monospaced", 1, 12));
    increButton.setBorder(BorderFactory.createRaisedBevelBorder());
    increButton.setText("++");
    decrButton.setFont(new java.awt.Font("Monospaced", 1, 12));
    decrButton.setBorder(BorderFactory.createRaisedBevelBorder());
    decrButton.setText("--");
    numberField.setFont(new java.awt.Font("Monospaced", 0, 12));
    numberField.setBorder(BorderFactory.createLoweredBevelBorder());
    numberField.setText("");
    numberField.setColumns(3);
    numberField.setMinimumSize( numberField.getPreferredSize() );
    this.setPreferredSize(new Dimension(1, 1));
    this.add(numberField, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(5, 5, 5, 5), 0, 0));
    this.add(increButton, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 2, 5, 5), 0, 0));
    this.add(decrButton, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 2), 0, 0));
    this.increButton.addActionListener( new ActionListener () {
          public void actionPerformed( ActionEvent ev ) { increment() ; } } );
    this.decrButton.addActionListener( new ActionListener () {
          public void actionPerformed( ActionEvent ev ) { decrement() ; } } );
    this.numberField.addActionListener( new ActionListener () {
          public void actionPerformed( ActionEvent ev ) { transfer() ; } } );
  }

  void setModel( BoundedRangeModel brm ) {
    this.brm = brm ;
    this.brm.addChangeListener( this );
    numberField.setText(brm.getValue()+""); }

  public void stateChanged( ChangeEvent ev ) {
    if( brm != null ) numberField.setText(brm.getValue()+""); }

  private void decrement() {
    if( brm != null ) brm.setValue( brm.getValue() - 1 ); }

  private void increment() {
    if( brm != null ) brm.setValue( brm.getValue() + 1 ); }

  private void transfer() {
    if( brm != null ) {
      String text = numberField.getText();
      int oldValue = brm.getValue() ;
      try {
        int val = Integer.parseInt(text) ;
        brm.setValue( val ); }
      catch( NumberFormatException ex ) {}
      numberField.setText(brm.getValue()+""); } }
}